import Head from 'next/head'
import type { GetServerSideProps, NextPage } from 'next'

import {
  PagesContainer,
  CardContainer,
  Searchbar,
  Pagination,
  Loader,
} from '../../components'
import { RepositoriesProps, Repository } from '../../types'
import { RepositoryCard } from '../../components/RepositoriesPage'
import { useState } from 'react'
import { usePagination, useSearch } from '../../hooks'
import { BASE_URL } from '../../const'

const Repositories: NextPage<RepositoriesProps> = ({ repositories }) => {
  const [repositoryToSearch, setRepositoryToSearch] = useState<string>()
  const { currentPage, setCurrentPage } = usePagination()
  const { data, loading, totalDataNumber } = useSearch<Repository[]>(
    repositoryToSearch
      ? `${BASE_URL}/search/repositories?q=${repositoryToSearch}&page=${currentPage}`
      : undefined
  )

  return (
    <>
      <Head>
        <title>Zebrands</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="logo" href="/logo.svg" />
      </Head>

      <PagesContainer>
        <Searchbar
          onChange={(repository) => setRepositoryToSearch(repository)}
        />
        <CardContainer>
          {loading ? (
            <Loader />
          ) : (
            <RepositoryCard repositories={data ?? repositories} />
          )}
        </CardContainer>
        <Pagination
          totalData={totalDataNumber}
          currentPage={currentPage}
          onHandlePaginate={setCurrentPage}
        />
      </PagesContainer>
    </>
  )
}

export default Repositories

export const getServerSideProps: GetServerSideProps = async () => {
  try {
    const apiResponse = await fetch(`${BASE_URL}/repositories`)
    const repositories: Repository[] = await apiResponse.json()
    return {
      props: {
        repositories,
      },
    }
  } catch (e) {
    return {
      props: {
        repositories: [],
      },
    }
  }
}
